#!/usr/bin/ruby -Ke

require 'cgi'
begin
  require 'etc'
rescue LoadError
  Etc = nil
end

def whois(format, uid, gid)
  uname = 'username not found'
  gname = 'groupname not found'
  if Etc
    begin
      uname = Etc.getpwuid(uid).name
      gname = Etc.getgrgid(gid).name
    rescue ArgumentError
    end
  end
  sprintf(format, uname, uid, gname, gid)
end

cgi = CGI.new('html4Tr')

cgi.out({'type' => 'text/html',
	  'charset' => 'iso-2022-jp'}) {
  cgi.html('PRETTY' => ' ') {				# <HTML>
    cgi.head {						# <HEAD>
      cgi.title {'Example 05'}				#  <TITLE></TITLE>
    } + cgi.body {					# </HEAD><BODY>
      cgi.h1 {'¹Իθ'} +				#  <H1></H1>
      cgi.ul {
	cgi.li {whois('UID/GID: %s(%s) / %s(%s)', 
		      Process::uid, Process::gid)} +
	cgi.li {whois('¸UID/GID: %s(%s) / %s(%s)',
		      Process::euid, Process::egid)}
      }
    }							#  </BODY>
  }							# </HTML>
}
